/*****************************************************************************\
*                                                                             *
*  ADJUST-MAP uses comparison arc frame[s] to make adjustments to a map file  *
*                                                                             *
*  VERSION  28 Jun 2005                                                       *
*                                                                             *
\*****************************************************************************/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "fitsio.h"
#include "cosmos.h"
#include "cpgplot.h"

float polyvalue(float,float[],int);
void plyfit(float*,float*,int,int,float*,double*,double*,double**);

int main(int argc,char *argv[]){

  char     CHAR,file[80],flnm[80],ifile[80],dfile[80],*DATA_DIR,line[140],
           *lin,name[40],dataline[6384],mfile[80],lnfile[80],lane[140],
           dewar[10],dfile2[80],tfile[80],tfile2[80],answer[80];
  int      INT,status,nelem,i,j,xdisper,ord_disp,ord_sag,ord_tilt,ord_sagit,
           ord_slen,nslit,chip,slitnum,search_height,search_width,iswmn,iswmx, 
           nsw,nline,n,islmx,islmn,nsl,il,ii,jj,ixtop,iytop,slit_width,nlv,
           ndline,breakpoint,ibin,ysign,narg, maxord,ord_ddisp,
           ord_dsag,nulvl,minlines,ixxtop2,ixtop2,iytop2,interp,nbad,
           ixxtop,iyytop,odsp,osag,nargd,diag,nlpts,cchp[300],niter,
           ord_dtilt,nsl1,ixxtop0,ixxtop1,otlt,nchip,anynl,debug,chipx,chipy,
           flx,nsl3,nsl7,nsl9,frint,prtl,tedge,k,da,dad,year,month,day;
  float    FLOAT,lambda0,lambda1,slit_len,slmin,slmax,x8,y8,lmin,lmax,lambda,
           xcen,ycen,slnt,ypos,xpos,x88,y88,sumax,sum,xshift[300],yshift[300],
           fac,factr[20],coef_disp[10],ynew,coef_sag[10],coef_tilt[10],
           coef_sagit[10],yp,ymid,edge,coef_slen[10],sline[300],slnth,slenth,
           tilt,slmx,slmn,aa,bb,bmx,bmn,lval[300],d_coef[10],t,s_coef[10],
           coef_xdisp[10],xval[300],lamshift[300],xnew,sum2,sumax2,sumax0,
           sumx0,sum0,sum1,sumx1,sumx2,invfrnt,sumax1,sumx,tshift[300],sumy0,
           cc,dd,sumy1,ypos2,t_coef[10],demin,demax,siglimit,wid,lval_b[300],
           xshift_b[300],stdev,d;
  long     naxes[3],firstel;
  int      *INTP,*image[9],*im,**array[9],*isx,*isy,*image2[9],*im2,
           **array2[9];
  float    *FLOATP,*ssx,*ssy,*laval,*deval;
  double   *xlist,*ylist,**elist,DOUBLE,*DOUBLEP;
  fitsfile *fptr[9],*sptr[9];
  FILE     *mapfile,*linefile,*newfile,*posfile;
  fitsdef  fitsinfo;
  dewdat    dewinfo;

  debug=1;
  edge=1.0;
  nulvl=interp=0;
  firstel=1;
  if(debug)posfile=fopen("adjust-map.dat","w");//debug
  minlines=2;                         //fit-order<=n_lines+minlines
  frint=1;

  //directories
  DATA_DIR=malloc(sizeof(CHAR)*80);
  DATA_DIR=getenv("COSMOS_IMAGE_DIR");
  if(DATA_DIR==NULL) die("COSMOS_IMAGE_DIR undefined!");
  strcat(DATA_DIR,"/");
  
  //get parameters
  
  strcpy(file,"adjust-map");
  if(OpenCosParm(file)!=0) die("cannot open parameter file");
  if(ReadParm_i("SEARCH_HEIGHT",&search_height)==1)die("Parameter file error");
  if(ReadParm_i("SEARCH_WIDTH",&search_width)==1)die("Parameter file error"); 
  if(ReadParm_i("SLIT_WIDTH",&slit_width)==1)die("Parameter file error");
  iswmn=-edge-(int)slit_width/2;
  iswmx=edge+(int)slit_width/2;
  for(i=0;i<iswmx+2;i++) factr[i]=exp(-i*i/(slit_width*slit_width*0.5));
  //for(i=0;i<iswmx+2;i++) factr[i]=0;
  factr[0]=1;
  nsw=iswmx-iswmn+1;
  if(ReadParm_i("ORD_DISP",&ord_ddisp)==1) die("Parameter file error");
  if(ReadParm_i("ORD_SAG",&ord_dsag)==1) die("Parameter file error");
  if(ReadParm_i("ORD_TILT",&ord_dtilt)==1) ord_dtilt=-1;
  ord_tilt=-1;
  if(ReadParm_s("LINELIST",lnfile)==1) die("Parameter file error");
  if(ReadParm_i("EDGE",&tedge)==1) die("Parameter file error");
  if(ReadParm_i("ITERATIONS",&niter)==1) die("Parameter file error");
  if(ReadParm_r("SIGLIMIT",&siglimit)==1) die("Parameter file error");
  linefile=fopen(lnfile,"r");
  if(linefile==NULL) die("cannot open line list file");
  
  //setup arrays
  maxord=ord_ddisp;
  maxord = (ord_dsag>maxord) ? ord_dsag: maxord;
  maxord = (ord_dtilt>maxord) ? ord_dtilt: maxord;
  maxord+=1;
  xlist=malloc(sizeof(DOUBLE)*2*maxord);                                 
  ylist=malloc(sizeof(DOUBLE)*maxord);                                
  elist=malloc(sizeof(DOUBLEP)*maxord);                         
  for(i=0;i<maxord;i++){
    *(elist+i)=malloc(sizeof(DOUBLE)*(maxord+1));}

  //get input files
  if(argc<5){
    while(1){
      printf("Enter map file name: ");
      scanf("%s",mfile);
      strcpy(file,mfile);
      if(strstr(file,".map")==NULL) strcat(file,".map");
      mapfile=fopen(file,"r");
      if(mapfile!=NULL) break;
      printf("mapfile %s does not exist!\n",file);
      }
    printf("Enter comparison arc frame name[s] CR=>end: ");
    scanf("%s",dfile);
    fgets(line,140,stdin);
    if(strncmp(line,"\n",1)){
      sscanf(line,"%s",&dfile2);
      interp=1;}
    }
  else{
    narg=nargd=diag=0;
    for(i=1;i<argc-1;i++){
      if(!(strcmp(argv[i],"-m"))){
	narg=i+1;
	continue;}
      if(!(strcmp(argv[i],"-d"))){
        nargd=i+1;
        continue;}
    }
    if(!narg) die("proper invocation: adjust-map -f framename -m mapfile\n");
    strcpy(mfile,argv[narg]);
    strcpy(file,mfile);
    if(strstr(file,".map")==NULL) strcat(file,".map");
    mapfile=fopen(file,"r");
    if(mapfile==NULL) die("Cannot open map file");
    narg=0;
    for(i=1;i<argc-1;i++){
      if(!(strcmp(argv[i],"-f"))){
	narg=i+1;
	break;}
      }
    strcpy(dfile,argv[narg]);
    if(argc>narg+1 && strcmp(argv[narg+1],"-m")&& strcmp(argv[narg+1],"-d")){
      interp=1;
      strcpy(dfile2,argv[narg+1]);
      if(!strcmp(dfile,dfile2)) die("Two data files must be different");}
    }
  if(nargd) sscanf(argv[nargd],"%d",&diag);
  strcpy(tfile,dfile);
  if(interp) strcpy(tfile2,dfile2);
  
  //output file
  if(!diag){
    if(interp){
      i=strlen(dfile);
      j=strlen(dfile2);
      if(!strcmp(&dfile[i-2],&dfile2[j-2]) && (!strcmp(&dfile[i-2],"_b") ||
                                             !strcmp(&dfile[i-2],"f"))){
        dfile[i-2]=dfile[i];
        i-=2;}
      if(strlen(dfile2)<i)i=strlen(dfile2);
      for(j=0;j<i;j++){
        if(dfile[j] != dfile2[j]) break;}   
      strcat(dfile,"-");
      strcat(dfile,dfile2+j);
      }
    if(!strcmp(mfile,dfile)){
      printf("spectral map %s.map moved to %s.map.old\n",mfile,mfile);
      strcat(mfile,".map");
      fclose(mapfile);
      strcpy(ifile,"mv ");
      strcat(ifile,mfile);
      strcat(ifile," ");
      strcat(mfile,".old");
      strcat(ifile,mfile);
      system(ifile);
      mapfile=fopen(mfile,"r");}
    lin=strrchr(dfile,'/');
    if(lin==NULL){
      lin=dfile;}
    else{
      lin+=1;}
    strcpy(file,lin);
    strcpy(dfile,file);
    strcat(dfile,".map");
    if((newfile=fopen(dfile,"w"))==NULL){
      printf("error opening output file %s\n",dfile);
      return 1;}
    //  strcpy(file,argv[3]);
  }
  
  //Read mapping data
  
  fgets(line,140,mapfile);
  if(!sscanf(line,"Xdispersion = %d",&xdisper)) die("Mapfile error");
  if(!diag) fprintf(newfile,"%s",line);
  fgets(line,140,mapfile);
  if(!sscanf(line,"Fit orders = %d %d %d %d %d",&ord_disp,&ord_sag,&ord_tilt,
             &ord_sagit,&ord_slen)) die("Mapfile error");
  if(ord_disp>9 || ord_sag>9 || ord_tilt>9 || ord_sagit>9 || ord_slen>9){
    printf("Warning: maximum fit order = 9\n");
    return 1;}
  if(!diag) fprintf(newfile,"%s",line);
  fgets(line,140,mapfile);
  if(!diag) fprintf(newfile,"%s",line);
  fgets(line,140,mapfile);
  if(!sscanf(line,"Lambda = %f %f",&lambda0,&lambda1)) die("Mapfile error");
  if(!diag) fprintf(newfile,"%s",line);
  fgets(line,140,mapfile);
  if(!sscanf(line,"Dewar = %s %d",dewar,&nchip)){
    strcpy(dewar,"SITE");                         //default for old map files
    if(!diag) fprintf(newfile,"Dewar = SITE 8\n");
    nchip=8;}
  else{
    if(!diag) fprintf(newfile,"%s",line);}
  if(Readcdf(dewar)==1){
    printf("Error reading dewar definition file %s\n",dewar);
    return 1;}
  Getchipdat(&dewinfo);
  chipx=dewinfo.xchip;
  chipy=dewinfo.ychip;
  //open files
  strcpy(flnm,DATA_DIR);
  strcat(flnm,tfile);
  strcpy(ifile,flnm);
  for(i=1;i<=nchip;i++){
    strcpy(file,ifile);
    if(nchip==1){
      strcat(file,".fits");}
    else{
      addbar(file);
      strcat(file,"c");
      sprintf(line,"%d.fits",i);
      strcat(file,line);}
    status=OpenFitsFile(file,&fptr[i],&fitsinfo);
    if(status) fits_die(file,status);}  
  //if 2 image files...
  if(interp){
    strcpy(flnm,DATA_DIR);
    strcat(flnm,tfile2);
    strcpy(ifile,flnm);
    for(i=1;i<=nchip;i++){
      strcpy(file,ifile);
      if(nchip==1){
        strcat(file,".fits");}
      else{
        addbar(file);
        strcat(file,"c");
        sprintf(line,"%d.fits",i);
        strcat(file,line);}
      status=(OpenFitsFile(file,&sptr[i],&fitsinfo));
      if(status) fits_die(file,status);}
    }
  
  
  //Check for correct SITE dewar
  sscanf(fitsinfo.date,"%d-%d-%d",&year,&month,&day);
  if(year>=2005 && month>=8){
    if(strstr(dewar,"SITE") != NULL && strstr(dewar,"SITE2")==NULL){
printf("\n***************************************************************\nWARNING: for IMACS data after Aug 1, 2005, you must specify the\n instrument as \"IMACS2\" in defineobs, or the dewar as \"SITE2\"\n in the dewar definition file. See documentation for details\n****************************************************************\n\n");
    return 1;}
  }
  //Read ccd data
  
  naxes[0]=fitsinfo.naxes[0];
  naxes[1]=fitsinfo.naxes[1];
  ibin=fitsinfo.binning;
  nelem=naxes[0]*naxes[1];
  ibin=fitsinfo.binning;
  status=0;
  for(i=1;i<=nchip;i++){
    image[i]=malloc(sizeof(INT)*naxes[0]*naxes[1]);
    im=image[i];
    array[i]=malloc(sizeof(INTP)*naxes[1]);
    for(j=0;j<naxes[1];j++) *(array[i]+j)=im+naxes[0]*j;
    status=ReadFitsFile(&fptr[i],&fitsinfo,TINT,im);
    if(status) fits_die("Error readinng image files",status);
    if(interp){
      image2[i]=malloc(sizeof(INT)*naxes[0]*naxes[1]);
      im2=image2[i];
      array2[i]=malloc(sizeof(INTP)*naxes[1]);
      for(j=0;j<naxes[1];j++) *(array2[i]+j)=im2+naxes[0]*j;
      status=ReadFitsFile(&sptr[i],&fitsinfo,TINT,im2);
      if(status) fits_die("Error readinng image files",status);}
    printf("Read ccd chip %d\r",i);
    fflush(stdout);}
  printf("\n");
 
  //Read line list

  nline=0;
  while((fgets(line,140,linefile))!=NULL){
    sscanf(line,"%f",&sline[nline]);
    nline++;}

  //if diag output
    if(diag){
    cpgopen("/xwindow");
    wid=6.;
    cpgpap(wid,1.);
    nlpts=(lambda1-lambda0+1);
    laval=malloc(sizeof(FLOAT)*nlpts);
    deval=malloc(sizeof(FLOAT)*nlpts);
    for(i=0;i<nlpts;i++) *(laval+i)=lambda0+i;
    }
  
   while(1){
    if(fgets(line,140,mapfile)==NULL)  die("Unexpected end to mapfile a");
    if(sscanf(line,"SLIT %d %s",&slitnum, name)) break;
    if(!diag) fprintf(newfile,"%s",line);}

  //New slit
  while(1){
    if(!diag) fprintf(newfile,"%s",line);
    if(!strncmp(line,"END",3)) break;                             //end of data
    if(!sscanf(line,"SLIT %d %s",&slitnum, name)) die(line);
    if((fgets(line,140,mapfile))==NULL) die("Unexpected end to mapfile b");
    if(!diag) fprintf(newfile,"%s",line);
    if(!strncmp(line,"END",3)) break;                             //end of data
    if(!sscanf(line,"LENGTH = %f",&slit_len)) continue;       //no data in slit

    //found a slit with data
    nslit++;
    nlv=0;
    ndline=0;
    //process all chips for this slit
    while(2){
      if((fgets(line,140,mapfile))==NULL) die("Unexpected end to mapfile c");
      if(!sscanf(line,"CHIP %d %f %f %f %f %d %d",&chip,&slmin,&slmax,&lmin,
                 &lmax,&i,&prtl)) break;
      strcpy(&dataline[ndline*140],line);
      ndline++;
      //coef_disp data
      if((fgets(line,140,mapfile))==NULL)die("Unexpected end to mapfile d");
      strcpy(&dataline[ndline*140],line);
      ndline++;
      lin=&line[0];
      for(i=0;i<=ord_disp;i++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL)
                                            die("Unexpected end to mapfile e");
        sscanf(lin,"%f",&coef_disp[i]);
        if((lin=strpbrk(lin," "))==NULL) die("Unexpected end to mapfile f");}

      //coef_xdisp dat
      if((fgets(line,140,mapfile))==NULL)die("Unexpected end to mapfile g");
      strcpy(&dataline[ndline*140],line);
      ndline++;
      lin=&line[0];
      for(i=0;i<=ord_disp;i++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL)
                                            die("Unexpected end to mapfile h");
        sscanf(lin,"%f",&coef_xdisp[i]);
        if((lin=strpbrk(lin," "))==NULL)die("Unexpected end to mapfile i");}
      //coef_sag dat
      if((fgets(line,140,mapfile))==NULL)die("Unexpected end to mapfile j");
      strcpy(&dataline[ndline*140],line);
      ndline++;
      lin=&line[0];
      for(i=0;i<=ord_sag;i++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL)
                                          die("Unexpected end to mapfile k");
        sscanf(lin,"%f",&coef_sag[i]);
        if((lin=strpbrk(lin," "))==NULL)die("Unexpected end to mapfile l");}
      //coef_tilt data
      if((fgets(line,140,mapfile))==NULL)die("Unexpected end to mapfile m");
      strcpy(&dataline[ndline*140],line);
      ndline++;
      lin=&line[0];
      for(i=0;i<=ord_tilt;i++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL)
                                            die("Unexpected end to mapfile n");
        sscanf(lin,"%f",&coef_tilt[i]);
        if((lin=strpbrk(lin," "))==NULL)die("Unexpected end to mapfile o ");}
      //coef_sagit data
      if((fgets(line,140,mapfile))==NULL)die("Unexpected end to mapfile p");
      strcpy(&dataline[ndline*140],line);
      ndline++;
      lin=&line[0];
      for(i=0;i<=ord_sagit;i++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL)
          die("Unexpected end to mapfile");
        sscanf(lin,"%f",&coef_sagit[i]);
        if((lin=strpbrk(lin," "))==NULL)die("Unexpected end to mapfile q");}
      //coef_slen data
      if((fgets(line,140,mapfile))==NULL)die("Unexpected end to mapfile r");
      strcpy(&dataline[ndline*140],line);
      ndline++;
      lin=&line[0];
      for(i=0;i<=ord_slen;i++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL)
          die("Unexpected end to mapfile");
        sscanf(lin,"%f",&coef_slen[i]);
        if((lin=strpbrk(lin," "))==NULL)die("Unexpected end to mapfile s");}
     
    
  /*---------------------------Tweak Map-------------------------------*/

      breakpoint=0;
      nslit=-1;
      
      //center each line
      
      slenth=slmax-slmin;
      for(n=0;n<nline;n++){
        
	//extraction box centered on line
	  
	lambda=sline[n];
	if(lambda<lmin || lambda>lmax) continue;
	xcen=polyvalue(lambda,coef_disp,ord_disp)/ibin;;	 
	ycen=polyvalue(lambda,coef_sag,ord_sag)/ibin;
	slnt=polyvalue(lambda,coef_slen,ord_slen)/ibin;
	tilt=polyvalue(lambda,coef_tilt,ord_tilt)/ibin;
	slmx=slmax*slnt/slenth;
	slmn=slmin*slnt/slenth;
	ymid=ycen+(slmx+slmn)/2.;
	ysign=1;
	if(slmx<slmn){
	  t=slmx;
	  slmx=slmn;
	  slmn=t;
	  ysign=-1;}
	islmx=(int)slmx+edge;
	islmn=(int)slmn-edge;
	slnth=slmx-slmn;
	nsl=islmx-islmn+1;
  nsl1=0.5*nsl;
  nsl3=0.3*nsl;
  nsl7=0.7*nsl;
  nsl9=0.9*nsl;
	//is search box completely on chip?
	aa=tilt*slmx/(slmx-slmn);
	bb=tilt*slmn/(slmx-slmn);
	bmx = (tilt>0) ? aa+search_width+xcen: bb+search_width+xcen;
	bmn= (tilt>0) ? bb-search_width+xcen: aa-search_width+xcen;
	if(xdisper){
	  if(bmx>chipx || bmn<0 || ycen+slmx+search_height> chipy  || 
	     ycen+slmn-search_height< 0 ) continue;}
	else{
	  if(bmx>chipy || bmn<0 || ycen+slmx+search_height> chipx  || 
	     ycen+slmn-search_height< 0 ) continue;}
	lval[nlv]=lambda;
	xval[nlv]=xcen;
	//interpolation arrays
	isx=malloc(sizeof(INT)*nsl);
	isy=malloc(sizeof(INT)*nsl);
	ssx=malloc(sizeof(FLOAT)*nsl);
	ssy=malloc(sizeof(FLOAT)*nsl);
	for(i=0;i<nsl;i++){
	  il=i+islmn;
	  aa=xcen+tilt*il/(slmx-slmn);
//   aa=xcen;
	  *(isx+i)=(int)aa;
	  *(ssx+i)=aa-*(isx+i);
	  aa=ycen+il;
	  *(isy+i)=(int)aa;
	  *(ssy+i)=aa-*(isy+i);}
	
	//peak up on line
	
	sumax=sumax2=0;
	breakpoint=0;
	for(i=-search_width;i<=search_width;i++){
	  for(j=-search_height;j<=search_height;j++){
	    sum=sum2=0;
	    //sum over extraction box
	    for(jj=0;jj<nsl;jj++){
	      for(ii=iswmn;ii<=iswmx;ii++){
		xpos=*(isx+jj)+i+ii+ *(ssx+jj);
		ypos=*(isy+jj)+j+ *(ssy+jj);
		if(!xdisper){
		  yp=xpos;
		  xpos=ypos;
		  ypos=yp;}
		if(xpos<0 || xpos>=naxes[0] || ypos<0 || ypos>=naxes[1]){
		  breakpoint=1;
		  break;}
		sum+=i_interpol(array[chip],naxes,xpos,ypos);
		if(interp)sum2+=i_interpol(array2[chip],naxes,xpos,ypos);}}
	    if(sum>sumax){
	      sumax=sum;
	      ixtop=i;
	      iytop=j;}
	    if(interp && sum2>sumax2){
	      sumax2=sum2;
	      ixtop2=i;
	      iytop2=j;}
	    }
	  if(breakpoint) break;}
	if(breakpoint) continue;

  // find x center of gravity of line
  
  sum=sumx=sum0=sumx0=sum1=sumx1=sum2=sumx2=sumy0=sumy1=0;
  //sum over extraction box
  for(jj=tedge;jj<nsl-tedge;jj++){
    for(ii=iswmn-1;ii<=iswmx+1;ii++){
      xpos=ixtop+ii+*(isx+jj)+ *(ssx+jj);
      ypos=iytop+*(isy+jj)+ *(ssy+jj);
      if(!xdisper){
        yp=xpos;
        xpos=ypos;
        ypos=yp;}
      flx=i_interpol(array[chip],naxes,xpos,ypos);
      if(jj<=nsl1){
        sum0+=flx;
        sumy0+=flx*jj;
        sumx0+=flx*ii;}
      else{
        sum1+=flx;
        sumy1+=flx*jj;
        sumx1+=flx*ii;}
      if(interp){
        xpos=ixtop2+ii+*(isx+jj)+ *(ssx+jj);
        ypos=iytop2+*(isy+jj)+ *(ssy+jj);
        if(!xdisper){
          yp=xpos;
          xpos=ypos;
          ypos=yp;}
        flx=i_interpol(array[chip],naxes,xpos,ypos);
        sum2+=flx;
        sumx2+=flx*ii;}
    }
  }
  sum=sum0+sum1;
  sumx=sumx0+sumx1;
  cchp[nlv]=chip;
  tshift[nlv]=-((sumx1/sum1)-(sumx0/sum0));
  tshift[nlv]*=nsl/((sumy1/sum1)-(sumy0/sum0));
  xshift[nlv]=ibin*(ixtop+sumx/sum);
  yshift[nlv]=ibin*iytop;
  if(interp){
    xshift[nlv]=0.5*(xshift[nlv]+ibin*(ixtop2+sumx2/sum2));
    yshift[nlv]=0.5*(yshift[nlv]+ibin*iytop2);}
  if(chip>4){                                             //SITE specific!!
    if(!xdisper){                                
	    xshift[nlv]=-xshift[nlv];
	    yshift[nlv]=-yshift[nlv];}
    }
  if(xdisper){
    xnew=ibin*xcen;
    ynew=ibin*ymid;}
  else{
    xnew=ibin*ycen;
    ynew=ibin*xcen;}
	mspos(chip,xnew,ynew,&x8,&y8);
//	if(debug)fprintf(posfile,"%d %s %8.2f %7.2f %7.2f %d %7.2f %7.2f %6.2f%6.2f\n",slitnum,name,lambda,x8,y8,chip,xnew,ynew,xshift[nlv],
//                   yshift[nlv]);
  free(isx);
	free(isy);
	free(ssx);
	free(ssy);
	nlv++;}//end of line loop
        }//end of chip loop

    //fit position corrections
    for(i=0;i<=ord_ddisp;i++) d_coef[i]=0.;
    for(i=0;i<=ord_dsag;i++) s_coef[i]=0;
    for(i=0;i<=ord_dtilt;i++) t_coef[i]=0;
    odsp=otlt=osag=-1;
    nbad=0;
    stdev=0;
    if(nlv>=minlines){
      for(j=0;j<niter;j++){
        if(ord_ddisp>=0){
          odsp = (nlv>=minlines+ord_ddisp) ? ord_ddisp : nlv-minlines;
          plyfit(lval,xshift,nlv,odsp,d_coef,xlist,ylist,elist);}
        if(ord_dsag>=0){
          osag = (nlv>=minlines+ord_dsag) ? ord_dsag : nlv-minlines;
          plyfit(lval,yshift,nlv,osag,s_coef,xlist,ylist,elist);}
        if(ord_dtilt>=0){
          otlt = (nlv>=minlines+ord_dtilt) ? ord_dtilt : nlv-minlines;
          plyfit(lval,tshift,nlv,otlt,t_coef,xlist,ylist,elist);}
        if(niter>1 && j<niter-1){
          for(i=0;i<nlv;i++)
                    stdev+=pow(xshift[i]-polyvalue(lval[i],d_coef,odsp),2.);
          stdev=siglimit*sqrt(stdev/nlv);
          i=0;
          while(i<nlv){
            d=fabs(xshift[i]-polyvalue(lval[i],d_coef,odsp));
//            printf("%f %f %f %f\n",lval[i],d,stdev,xshift[i]);
            if(d>stdev){
              xshift_b[nbad]=xshift[i];
              lval_b[nbad]=lval[i];
              nbad++;
              nlv--;
              for(k=i;k<nlv;k++){
                xshift[i]=xshift[i+1];
                lval[i]=lval[i+1];}
            }
            i++;}
        }
      }
    }
    else{
        printf("Insuffient data to correct slit %d\n",slitnum);
      fflush(stdout);}
      
    //plot diagnostics
    if(diag){
      da=slitnum/diag;
      dad=da*diag;}
    if(dad==slitnum){
      cpgpage;
      cpgsch(1);
      cpgscr(0,1,1,1);
      cpgscr(1,0,0,0);
      cpgask(0);
      cpgsci(1);
      demin=10000;
      demax=-10000;
      for(i=0;i<nlv;i++){
//        printf("%d %7.1f %3.1f\n",cchp[i],lval[i],xshift[i]);
        if(xshift[i]<demin) demin=xshift[i];
        if(xshift[i]>demax) demax=xshift[i];}
      for(i=0;i<nlpts;i++){
        *(deval+i)=polyvalue(lambda0+i,d_coef,odsp);
        if(*(deval+i)<demin) demin=*(deval+i);
        if(*(deval+i)>demax) demax=*(deval+i);}
      demin-=1;
      demax+=1;
      cpgenv(lambda0,lambda1,demin,demax,0,0);
      cpglab("Lambda","D Lambda",name);
      cpgsch(10);
      cpgsci(3);
      cpgpt(nlv,lval,xshift,1);
      cpgsci(2);
      cpgpt(nbad,lval_b,xshift_b,1);
      cpgsci(1);
      cpgline(nlpts,laval,deval);
      cpgsci(1);
      printf("Hit CR to continue, Q to quit: ");
      fflush(stdout);
      fgets(answer,80,stdin);
      if(!strncasecmp(answer,"q",1)) return 0;
      cpgclos;}
    //or apply corrections
    if(!diag){
    i=0;
      printf("Correcting slit %d\r",slitnum);
      fflush(stdout);
      while(i<ndline){
      //chip data
      strncpy(lane,&dataline[i*140],140);
      i++;
      sscanf(lane,"CHIP %d",&chip);
      fprintf(newfile,"%s",lane);
      //x=f(lambda)
      strncpy(lane,&dataline[i*140],140);
      i++;
      lin=&lane[0];
      for(ii=0;ii<=ord_disp;ii++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL){
          printf("Unexpected end to mapfile slit %d\n line = %s",slitnum,lin);
          return 1;}
        sscanf(lin,"%f",&coef_disp[ii]);
        if((lin=strpbrk(lin," "))==NULL){
          printf("Unexpected end to mapfile slit %d d\n",slitnum);
          return 1;}}
      for(j=0;j<=ord_ddisp;j++){
        if(isnan(d_coef[0])) break;
        if(xdisper || chip<=4){                           //SITE specific!!
          coef_disp[j]+=d_coef[j];}
        else{
          coef_disp[j]-=d_coef[j];}
	    }
      for(ii=0;ii<=ord_disp;ii++) fprintf(newfile,"%13.6e ",coef_disp[ii]);
          fprintf(newfile,"\n");
      //lambda=f(x)
      strncpy(lane,&dataline[i*140],140);
      i++;
      lin=&lane[0];
      for(ii=0;ii<=ord_disp;ii++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL){
          printf("Unexpected end to mapfile slit %d c\n",slitnum);
          return 1;}
        sscanf(lin,"%f",&coef_xdisp[ii]);
        if((lin=strpbrk(lin," "))==NULL){
          printf("Unexpected end to mapfile slit %d d\n",slitnum);
          return 1;}}
      //	for(j=0;j<=odsp;j++){
      //	  coef_xdisp[j]+=x_coef[j];}
      for(ii=0;ii<=ord_disp;ii++) fprintf(newfile,"%13.6e ",coef_xdisp[ii]);
      fprintf(newfile,"\n");
      //y=f(lambda)
      strncpy(lane,&dataline[i*140],140);
      i++;
      lin=&lane[0];
      for(ii=0;ii<=ord_sag;ii++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL){
          printf("Unexpected end to mapfile slit %d f\n",slitnum);
          return 1;}
        sscanf(lin,"%f",&coef_sag[ii]);
        if((lin=strpbrk(lin," "))==NULL){
          printf("Unexpected end to mapfile slit %d g\n",slitnum);
          return 1;}
	    }
      for(j=0;j<=osag;j++){
        if(isnan(s_coef[0])) break;
        if(xdisper || chip<=4){                           //SITE specific!!
          coef_sag[j]+=s_coef[j];}
        else{
          coef_sag[j]-=s_coef[j];}
	    }
      for(ii=0;ii<=ord_sag;ii++) fprintf(newfile,"%13.6e ",coef_sag[ii]);
          fprintf(newfile,"\n");
      //tilt
      strncpy(lane,&dataline[i*140],140);
      i++;
      lin=&lane[0];
      for(ii=0;ii<=ord_tilt;ii++){
        if((lin=strpbrk(lin,"1234567890.-"))==NULL){
          printf("Unexpected end to mapfile slit %d f\n",slitnum);
          return 1;}
        sscanf(lin,"%f",&coef_tilt[ii]);
        if((lin=strpbrk(lin," "))==NULL){
          printf("Unexpected end to mapfile slit %d g\n",slitnum);
          return 1;}
      }
      for(j=0;j<=otlt;j++){
        if(isnan(t_coef[0])) break;
        coef_tilt[j]+=t_coef[j];}
      for(ii=0;ii<=ord_tilt;ii++) fprintf(newfile,"%13.6e ",coef_tilt[ii]);
      fprintf(newfile,"\n");
      
      //other functions
      for(j=0;j<2;j++){
        strncpy(lane,&dataline[i*140],140);
        fprintf(newfile,"%s",lane);
        i++;}
    }
  }
  }
  return 0;}


	
	
	
